#!/usr/bin/env python
# PyTube is a small script for downloading YouTube videos and converting them into multiple selected formats
# Depends on:  youtube-dl, mplayer, mencoder

import webbrowser,time
try:
	import pygtk
	pygtk.require("2.0")
except:
	pass
try:
	import gtk
	import gtk.glade
	import pynotify
except:
	sys.exit(1)
try:
	import os
	import sys
except:
	sys.exit(1)

# Search for necesarry files, if not found then PyTube will quit
for i in ["/usr/bin/youtube-dl","/usr/bin/mencoder","/usr/bin/mplayer","/usr/bin/ffmpeg2theora","/usr/bin/oggenc"]:
    if os.path.isfile(i):
        print i+" present :-)"
    else:
        os.system("zenity --error --text="+i+"\ was\ not\ found.")
        sys.exit(1)

class PyTubeGUI:
	def __init__(self):
		self.gladefile = "pytubegui.glade"
		self.wTree = gtk.glade.XML(self.gladefile, "mainwindow")
		self.window = self.wTree.get_widget("mainwindow")
		dic = { "on_imagemenuitem5_activate" : gtk.main_quit,
			"on_toolbutton1_clicked" : gtk.main_quit,
			"on_mainwindow_destroy" : gtk.main_quit,
			"on_imagemenuitem10_activate" : self.ShowAbout,
			"on_button3_clicked" : self.ShowDownload,
			"on_toolbutton3_clicked" : self.ShowAbout,
			"on_menuitem2_activate" : self.Clean,
			"on_youtubelink_clicked" : self.YouTubeTab,
			"on_localfilebtn_clicked" : self.LocalTab,
			"on_combobox1_changed" : self.HideDelete,
			"on_accountcheck_toggled" : self.AccountView}
		self.wTree.signal_autoconnect(dic)
		self.wTree.get_widget("combobox1").set_active(3)
		self.wTree.get_widget("combobox2").set_active(0)
		self.wTree.get_widget("filechooserbutton1").set_filename(os.path.expanduser("~"))
		self.wTree.get_widget("filechooserbutton3").set_filename(os.path.expanduser("~"))
		self.wTree.get_widget("notebook1").set_current_page(0)
	def AccountView(self, widget):
		if self.wTree.get_widget("accountcheck").get_active()==False:
			self.wTree.get_widget("label3").hide()
			self.wTree.get_widget("label4").hide()
			self.wTree.get_widget("username").hide()
                        self.wTree.get_widget("password").hide()
			self.wTree.get_widget("accountcheck").set_label("Use my YouTube Account ")
		else:
			self.wTree.get_widget("accountcheck").set_label("Use my YouTube Account: ")
			self.wTree.get_widget("label3").show()
                        self.wTree.get_widget("label4").show()
			self.wTree.get_widget("username").show()
                        self.wTree.get_widget("password").show()
	def YouTubeTab(self, widget):
		self.wTree.get_widget("notebook1").set_current_page(0)
	def LocalTab(self, widget):
		self.wTree.get_widget("notebook1").set_current_page(1)
	def HideDelete(self, widget):
		if (self.wTree.get_widget("combobox1").get_active()==4) or (self.wTree.get_widget("combobox1").get_active()==5) or \
(self.wTree.get_widget("combobox1").get_active()==6):
                        self.wTree.get_widget("checkdelete").show()
                else:
                        self.wTree.get_widget("checkdelete").hide()
	def Clean(self, widget):
		self.wTree.get_widget("accountcheck").set_active(0)
		self.wTree.get_widget("notebook1").set_current_page(0)
		self.wTree.get_widget("combobox1").set_active(3)
		self.wTree.get_widget("entry1").set_text("")
		self.wTree.get_widget("filechooserbutton1").set_filename(os.path.expanduser("~"))
		self.wTree.get_widget("notebook1").set_current_page(0)
                self.wTree.get_widget("combobox2").set_active(0)
                self.wTree.get_widget("filechooserbutton3").set_filename(os.path.expanduser("~"))
		self.wTree.get_widget("checkdelete").set_active(0)
	def ShowAbout(self, widget):
		gtk.about_dialog_set_url_hook(self.LaunchBrowser)
		self.about = gtk.glade.XML(self.gladefile, "aboutdialog", "About PyTube")
		self.aboutdlg = self.about.get_widget("aboutdialog")
	def LaunchBrowser(self, widget, link):
	 	webbrowser.open(link)
	def ShowDownload(self, widget):
		icon = "file://" + os.path.abspath(os.path.curdir) + "/applications-internet.png"
                icon2 = "file://" + os.path.abspath(os.path.curdir) + "/audio-x-generic.png"
                icon3 = "file://" + os.path.abspath(os.path.curdir) + "/video-x-generic.png"
                icon4 = "file://" + os.path.abspath(os.path.curdir) + "/dialog-information.png"  
		accountcheck = self.wTree.get_widget("accountcheck").get_active()
		username = self.wTree.get_widget("username").get_text()
		password = self.wTree.get_widget("password").get_text()
		if (self.wTree.get_widget("notebook1").get_current_page()==0) and not(self.wTree.get_widget("notebook1").get_current_page()==1):
			videolink = self.wTree.get_widget("entry1").get_text()
			videosave = self.wTree.get_widget("filechooserbutton1").get_filename() + "/"
			if str(videolink)=="":
				if not (pynotify.init("Basics")) and not (pynotify.init("Markup")) and not(pynotify.init("Replace")):
                                        sys.exit(1)
                                messagedownload = pynotify.Notification("Error", "Please enter a YouTube Video link.", icon4)
                                if not messagedownload.show():
                                        print "Failed to send notification"
                                        sys.exit(1)
			elif ("http://youtube.com/watch?v=" in str(videolink)) or ("http://www.youtube.com/watch?v=" in str(videolink)) or ("www.youtube.com/watch?v=" in str(videolink)) or ("youtube.com/watch?v=" in str(videolink)):
				finalvideo = videolink.split("v=")[1]
				format = self.wTree.get_widget("combobox1").get_active()
				if not (pynotify.init("Basics")) and not (pynotify.init("Markup")) and not(pynotify.init("Replace")):
       			 		sys.exit(1)
				messagedownload = pynotify.Notification("Downloading Video ", "<i>\n" + finalvideo + "</i>\n\nThis message will close once \
this task has finished.", icon)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
       					print "Failed to send notification"
      					sys.exit(1)
				print "Option Chosen: %s" %str(format)
				print "Output Directory: %s " %str(videosave)
				print "Output File: %s.flv" %str(videosave+finalvideo)
				print accountcheck
				if (format==0) or (format==-1): # Theora Video
					os.chdir(videosave)
					if accountcheck==False:
						os.system("youtube-dl %s" %str(videolink))
					else:
						 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.update("Converting Video ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon3)
					if not messagedownload.show():
       			 			print "Failed to send notification"
       						sys.exit(1)
					os.system("ffmpeg2theora -v 10 --optimize --sync " + str(videosave+finalvideo) + ".flv -o " + str(videosave+finalvideo) + \
".ogm")
					if self.wTree.get_widget("checkdelete").get_active()==False:
						os.remove(str(videosave+finalvideo)+".flv")
					messagedownload.close()
				if format==1: #  MPG Video
					os.chdir(videosave)
       			         	if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
       	       		          	messagedownload.update("Converting Video ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon3)
	                        	if not messagedownload.show():
       	                        	 	print "Failed to send notification"
       	                        		sys.exit(1)
 		                 	os.system("mencoder -of mpeg -ovc lavc -lavcopts vcodec=mpeg1video -oac copy " + str(videosave+finalvideo) + ".flv -o " + 
\
str(videosave+finalvideo) + ".mpg")
 		       	                if self.wTree.get_widget("checkdelete").get_active()==False:
                                                os.remove(str(videosave+finalvideo)+".flv")
               			        messagedownload.close()
				if format==2: # AVI Video
					os.chdir(videosave)
					if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.update("Converting Video ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon3)
    	        	            	if not messagedownload.show():
        	                       	 	print "Failed to send notification"
                       		         	sys.exit(1)
            		            	os.system("mencoder " + str(videosave+finalvideo) + ".flv -o " + str(videosave+finalvideo) + ".avi -ovc copy -oac mp3lame")
					if self.wTree.get_widget("checkdelete").get_active()==False:
                                                os.remove(str(videosave+finalvideo)+".flv")
                              		messagedownload.close()
				if format==3: # FLV Video
					os.chdir(videosave)
					if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.close()
				if format==4: # Audio Only (mp3)
					os.chdir(videosave)
					if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.update("Extracting Audio ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon2)
					if not messagedownload.show():
      	         	                	print "Failed to send notification"
      	         		                sys.exit(1)
					os.system("mplayer -dumpaudio " + str(videosave+finalvideo)+ ".flv -dumpfile " + str(videosave+finalvideo) + ".mp3") 
					if self.wTree.get_widget("checkdelete").get_active()==False:
                                                os.remove(str(videosave+finalvideo)+".flv")
					messagedownload.close()
				if format==5: # Audio Only (ogg)
					os.chdir(videosave)
					if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.update("Extracting Audio ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon2)
					if not messagedownload.show():
       			                        print "Failed to send notification"
       		        	                sys.exit(1)
					os.system("mplayer -vo null -ao pcm:file=" + str(videosave+finalvideo)+ ".wav " + str(videosave+finalvideo) + ".flv")
					messagedownload.update("Converting Audio", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon2)
					if not messagedownload.show():
       	        	        	       print "Failed to send notification"
       	        		               sys.exit(1)
					os.system("oggenc -q5 " + str(videosave+finalvideo) + ".wav -o " + str(videosave+finalvideo) + ".ogg")
					if self.wTree.get_widget("checkdelete").get_active()==False:
                                                os.remove(str(videosave+finalvideo)+".flv")
					messagedownload.close()
				if format==6: # Audio Only (wav)
					os.chdir(videosave)
					if accountcheck==False:
                                                os.system("youtube-dl %s" %str(videolink))
                                        else:
                                                 os.system("youtube-dl -u " + str(username) + " -p " + str(password) + " %s" %str(videolink))
					messagedownload.update("Extracting Audio ", "<i>\n" +  videolink.split("v=")[1] + "</i>\n\nThis message will close once this task \
has finished.", icon2)
					if not messagedownload.show():
       			                        print "Failed to send notification"
	       	         	                sys.exit(1)
					os.system("mplayer -ao pcm:file=" + str(videosave+finalvideo) + ".wav -vo null " + str(videosave+finalvideo) + ".flv" )
					if self.wTree.get_widget("checkdelete").get_active()==False:
                                                os.remove(str(videosave+finalvideo)+".flv")
					messagedownload.close()
			
			else:
				if not (pynotify.init("Basics")) and not (pynotify.init("Markup")) and not(pynotify.init("Replace")):
                                        sys.exit(1)
				icon = "file://" + os.path.abspath(os.path.curdir) + "/dialog-error.png"
				messagedownload = pynotify.Notification("Error", "The link you have provided is invalid", icon)
                                if not messagedownload.show():
                                	print "Failed to send notification"
                                	sys.exit(1)
		if (self.wTree.get_widget("notebook1").get_current_page()==1) and not(self.wTree.get_widget("notebook1").get_current_page()==0):
			icon2 = "file://" + os.path.abspath(os.path.curdir) + "/audio-x-generic.png"
	                icon3 = "file://" + os.path.abspath(os.path.curdir) + "/video-x-generic.png"
			if not (pynotify.init("Basics")) and not (pynotify.init("Markup")) and not(pynotify.init("Replace")):
                                sys.exit(1)
			videopathsplit = self.wTree.get_widget("filechooserlocal").get_filename().split(".flv")
			localvideo = videopathsplit[0]
			format = self.wTree.get_widget("combobox2").get_active()
			messagedownload = pynotify.Notification("Local file selected", str(localvideo)[0]+".flv")
			messagedownload.set_timeout(10000)
			if not messagedownload.show():
                                        print "Failed to send notification"
                                        sys.exit(1)
			if (format==0) or (format==-1): # Theora Video
				messagedownload.update("Converting Video ", "<i>\n" + str(localvideo) + "</i>\n\nThis message will close once this task has \
finished.", icon3)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
       		 			print "Failed to send notification"
       					sys.exit(1)
				os.system("ffmpeg2theora -v 10 --optimize --sync " + str(localvideo) + ".flv -o " + str(localvideo) + ".ogm")
				messagedownload.close()
			if format==1: #  MPG Video
       	                 	messagedownload.update("Converting Video ", "<i>\n" + str(localvideo)  + "</i>\n\nThis message will close once this task has \
finished.", icon3)
				messagedownload.set_timeout(0)
                        	if not messagedownload.show():
                               	 	print "Failed to send notification"
                               		sys.exit(1)
                        	os.system("mencoder -of mpeg -ovc lavc -lavcopts vcodec=mpeg1video -oac copy " + str(localvideo) + ".flv -o " + str(localvideo) + ".mpg")
               		        messagedownload.close()
			if format==2: # AVI Video
				messagedownload.update("Converting Video ", "<i>\n" + str(localvideo) + ".flv </i>\n\nThis message will close once this task has \
finished.", icon3)
				messagedownload.set_timeout(0)
                        	if not messagedownload.show():
                               	 	print "Failed to send notification"
                                	sys.exit(1)
                        	os.system("mencoder " + str(localvideo) + ".flv -o " + str(localvideo) + ".avi -ovc copy -oac mp3lame")
                        	messagedownload.close()
			if format==3: # Audio Only (mp3)
				messagedownload.update("Extracting Audio ", "<i>\n" +  str(localvideo) + "</i>\n\nThis message will close once this task has \
finished.", icon2)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
               	                	print "Failed to send notification"
               		                sys.exit(1)
				os.system("mplayer -dumpaudio " + str(localvideo) + ".flv -dumpfile " + str(localvideo) + ".mp3") 
				messagedownload.close()
			if format==4: # Audio Only (ogg)
				messagedownload.update("Extracting Audio ", "<i>\n" +  str(localvideo) + "</i>\n\nThis message will close once this task has \
finished.", icon2)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
       		                        print "Failed to send notification"
       	        	                sys.exit(1)
				os.system("mplayer -vo null -ao pcm:file=" + str(localvideo) + ".wav " + str(localvideo) + ".flv")
				messagedownload.update("Converting Audio", "<i>\n" +  str(localvideo) + "</i>\n\nThis message will close once this task has \
finished.", icon2)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
               	        	       print "Failed to send notification"
               		               sys.exit(1)
				os.system("oggenc -q5 " +  str(localvideo) + ".wav" + " -o " +  str(localvideo) + ".ogg")
				os.remove(str(localvideo) + ".wav")
				messagedownload.close()
			if format==5: # Audio Only (wav)
				messagedownload.update("Extracting Audio ", "<i>\n" +  str(localvideo) + "</i>\n\nThis message will close once this task has \
finished.", icon2)
				messagedownload.set_timeout(0)
				if not messagedownload.show():
       		                        print "Failed to send notification"
                	                sys.exit(1)
				os.system("mplayer -vo null -ao pcm:file=" + str(localvideo) + ".wav " + str(localvideo) + ".flv" )
				messagedownload.close()			

if __name__ == "__main__":
	program = PyTubeGUI()
	gtk.main()
